package net.hasiru.axis.services;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.sql.DataSource;

public class DAO {
	private static final String BEGINW = "BEGIN WORK";
	private static final String ROLLBACKW = "ROLLBACK WORK";
	private static final String LOCKIPS = "LOCK TABLE ips IN ACCESS SHARE MODE";	
	private static final String GETIP = "SELECT * FROM ips WHERE ip = ?";

	private InitialContext initContext;
    private Context envContext;
    private DataSource source;
    public DAO(){
    	try{
            this.initContext = new InitialContext();
            this.envContext = (Context)initContext.lookup("java:/comp/env");
    	    this.source = (DataSource)envContext.lookup("jdbc/postgres");
    	}catch(Exception ex){
    		return;
    	}
    }
   
    public String getIp(String ip) throws SQLException{
    	String rt = "";
        Connection con = null;
        PreparedStatement pStmt = null;
        ResultSet rs = null;
        try {
            con = this.source.getConnection();
            pStmt = con.prepareStatement(BEGINW);
            pStmt.execute();
            pStmt.close();
            pStmt = null;
            pStmt = con.prepareStatement(LOCKIPS);
            pStmt.execute();
            pStmt.close();
            pStmt = null;            
            pStmt = con.prepareStatement(GETIP);
            pStmt.setString(1, ip);
            rs = pStmt.executeQuery();
            if (rs.next()) {
            	rt= rs.getString("ip");
            }
       } catch (SQLException ex) {
            throw ex;
       } catch (Exception ee) {
           	throw new SQLException(ee.getMessage());
       } finally {
            if(rs != null){
            	rs.close();
           	}
           	if(pStmt != null){
           		pStmt.close();
            }
            if(con != null){
             	pStmt = con.prepareStatement(ROLLBACKW);
        		pStmt.execute();
        		pStmt.close();            	
        		con.close();
            }
        }   	
    	return rt;
    }
}
